<?php

# Navigation for the i-scream alerts.
# pjm2@ukc.ac.uk
#
# CONFIGURABLE CONSTANTS: -

include("alerts_config.inc.php");

#
# END CONFIGURATION

include("iutils.inc.php");

function printLine($title) {
    echo "<hr style=\"color:#9999ff;\">";
    echo "<b>$title</b>";
}

function getValue($value, $alert) {
    preg_match("/$value=([^\,\}]*)[\,\}]/", $alert, $matches);
    return $matches[1];
}

function printAlert($machine, $alert, $small="") {

    global $fontsize;

    include("alerts_config.inc.php");

    $alertLevelNum = getValue("alertLevel", $alert);
    $lastAlert = getValue("lastAlert", $alert);
    $thresholdLevel = getValue("thresholdLevel", $alert);
    $source = getValue("source", $alert);
    $thresholdValue = getValue("thresholdValue", $alert);
    $value = getValue("value", $alert);
    $attributeName = getValue("attributeName", $alert);
    $timeTillNextAlert = getValue("timeTillNextAlert", $alert);
    $initialAlertTime = getValue("initialAlertTime", $alert);

    if ($thresholdLevel == "1") {
        $thresholdLevel = "Lower";
    }
    else if ($thresholdLevel == "2") {
        $thresholdLevel = "Upper";
    }
    else {
        $thresholdLevel = "Normal";
    }

    $alertColour = $alertLevelColours[$alertLevelNum];
    $alertLevel = $alertLevelNames[$alertLevelNum];
    $initialAlertTime = strftime("%x %X", intval($initialAlertTime / 1000));

    if ($small == "on") {
        echo <<<EOT
            <tr>
             <td width="50">
              &nbsp;
             </td>
             <td>
              <img src="level$alertLevelNum.gif" width="41" height="9" border="0" alt="$alertLevel">
             </td>
             <td>
              <font size="$fontsize" color="$alertColour"><b>$alertLevel</b></font>
             </td>
             <td>
              <font size="$fontsize">$attributeName</font>
             </td>
             <td>
              &nbsp;
             </td>
            </tr>
EOT;
    }
    else {
        echo <<<EOT
        
        <table border="0" cellspacing="5" width="100%">
          <tr>
            <td align="left" width="40%">
              <img src="level$alertLevelNum.gif" width="41" height="9" border="0" alt="$alertLevel">
              <font color="$alertColour" size="2"><b>$alertLevel</b></font>
            </td>
            <td align="right" width="60%">
              <b>$attributeName</b>
            </td>
          </tr>
          <tr>
            <td align="right"><font size="2">Threshold:</font></td>
            <td align="left">$thresholdValue ($thresholdLevel)</td>
          </tr>
          <tr>
            <td align="right"><font size="2">Alert value:</font></td>
            <td align="left"><b>$value</b></td>
          </tr>
          <tr>
            <td align="right"><font size="2">Initially raised:</font></td>
            <td align="left">$initialAlertTime</td>
          </tr>
        </table>
            
EOT;
        printLine("");
    }

}

function printReports($machine, $small="") {
    global $fontsize;

    # Get a list of all files in the machine's directory.
    include("alerts_config.inc.php");
    $alertArray = getdirArray("$alertDirectory/$machine", 'rsort');
   
    if ($small == "on") {
        echo <<<EOT
           <table border="0" cellpadding="2" cellspacing="6">
            <tr>
             <td colspan="5">
              <font size="$fontsize"><b><a href="alerts.php?machine=$machine" style="color: black; text-decoration: none;">$machine</a></b></font>
             </td>
            </tr>
EOT;
    }
    else {
        echo <<<EOT
             <p>&nbsp;</p>
             <table border="0" cellpadding="3" cellspacing="2" bgcolor="#000066" width="100%">
              <tr>
               <td>
                <font color="white">
                 <b>
                  Current alerts for <a href="latest.php?machine=$machine" style="color: white">$machine</a>
                 </b>
                 <font size="2">
                  <br>Sorted by time, latest first.
                 </font>
                </font>
               </td>
              </tr>
              <tr>
               <td bgcolor="white">
    
EOT;

        printLine("");
    }
   
    if ($alertArray != FALSE) {

        foreach($alertArray as $file_name) {
            $input = file("$alertDirectory/$machine/$file_name");
            $input = $input[0];
            $alerts[] = $input;
        }
       
        foreach ($alerts as $alert) {
            printAlert($machine, $alert, $small);
        }
    }
    else {
        if ($small != "on") {
            echo "There are currently no alerts held about <b>$machine</b>";
            printLine("");
        }
    }

    if ($small == "on") {
        echo <<<EOT
            <tr>
             <td colspan="5">&nbsp;</td>
            </tr>
           </table>
EOT;
    }
    else {
        echo <<<EOT
             </td>
            </tr>
           </table>
EOT;
    }
}


?>

<? include($titleHTML); ?>

<? if ($hideform != "on") { ?>

<? printLine("Latest alerts for hosts"); ?>

<form method="<? echo $formMethod ?>" action="<? echo $thisPage ?>">
<?

    $file_array = getdirArray($alertDirectory,'asort');
    print "<select size=\"1\" name=\"machine\">";
    if ($machine) { ?>
        <option selected value="<? echo $machine ?>"><? echo $machine ?></option>
        <option value="">----------------</option>
    <? }
    foreach ($file_array as $file_name) {
        #if (is_dir($file_name)) {
            print "<option value=\"$file_name\">$file_name</option>";
        #}
    }
    print "</select>";

?>
 <input type="hidden" name="small" value="<?=$small?>">
 <input type="submit" name="submit" value="Display">
</form>

<? } ?>

<? if ($machine) {

       printLine("");

       $masterwidth = "";
       if ($small != "on") {
           $masterwidth = ' width="100%"';
       }

       echo <<<EOT
        <table border="0" align="center"$masterwidth>
         <tr>
          <td>
EOT;

       if ($machine == "ALL") {
           $machine_array = getdirArray($alertDirectory, 'asort');
           if ($machine_array != FALSE) {
               foreach ($machine_array as $machine) {
                   printReports($machine, $small);
               }
           }
       }
       else {
           printReports($machine, $small);
       }
       
       echo <<<EOT
         </td>
        </tr>
       </table>
EOT;
   }
   else {
       printLine("");
   }

?>

<? include($bottomHTML); ?>
